/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


#include <windows.h>
#include <vfw.h>
#include <DV.h>


#define VERSION_L L"0.1.5"
#define CODEC_NAME_L L"Cedocida DV codec"
#define CODEC_DESCRIPTION_L L"Cedocida DV codec (SD format) v"VERSION_L

static const DWORD FOURCC_DVSD = mmioFOURCC('d','v','s','d');   // DV standard
static const DWORD FOURCC_VYUY = mmioFOURCC('V','Y','U','Y');   // an alias for YUY2 used by ATI cards
static const DWORD FOURCC_UYVY = mmioFOURCC('U','Y','V','Y');   // uncompressed UYVY
static const DWORD FOURCC_YUY2 = mmioFOURCC('Y','U','Y','2');   // uncompressed YUY2
static const DWORD FOURCC_YUYV = mmioFOURCC('Y','U','Y','V');   // uncompressed YUYV - same as YUY2
static const DWORD FOURCC_V422 = mmioFOURCC('V','4','2','2');   // uncompressed V422 - same as YUY2
static const DWORD FOURCC_YVYU = mmioFOURCC('Y','V','Y','U');   // uncompressed YVYU
static const DWORD FOURCC_YV12 = mmioFOURCC('Y','V','1','2');   // uncompressed YV12



/****************************************
	global configuration
****************************************/

int load_configuration( char *filename );


/****************************************
	helper datatypes
****************************************/

struct cedocida_state_t 
{
	int dummy;
};
																
/****************************************
	helper functions
****************************************/

static bool is_YUY2(LPBITMAPINFOHEADER lpbiIn);
static bool is_RGB24(LPBITMAPINFOHEADER lpbiIn);

/****************************************
	standard driver messages
****************************************/

DWORD my_drv_configure(LPARAM lParam1, LPARAM lParam2);

/****************************************
	state messages
****************************************/

DWORD my_icm_about(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_configure(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_getstate(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_setstate(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_getinfo(LPARAM lParam1, LPARAM lParam2);

/****************************************
	compress messages
****************************************/

DWORD my_icm_compress_query(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_compress_get_format(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_get_size(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_compress_begin(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_compress(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_compress_end(LPARAM lParam1, LPARAM lParam2);

/****************************************
	decompress messages
****************************************/

DWORD my_icm_decompress_query(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_decompress_get_format(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_decompress_begin(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_decompress(LPARAM lParam1, LPARAM lParam2);
DWORD my_icm_decompress_end(LPARAM lParam1, LPARAM lParam2);
