/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/


// weight and quantize tables

const int16_t quantization_step_88_extended[13*64] = {
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,

	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  2,
	 1,  1,  1,  1,  1,  1,  2,  2,
	 1,  1,  1,  1,  1,  2,  2,  2,
	 1,  1,  1,  1,  2,  2,  2,  2,
	 1,  1,  1,  2,  2,  2,  2,  2,
	 1,  1,  2,  2,  2,  2,  2,  2,

	 1,  1,  1,  1,  1,  1,  2,  2,
	 1,  1,  1,  1,  1,  2,  2,  2,
	 1,  1,  1,  1,  2,  2,  2,  2,
	 1,  1,  1,  2,  2,  2,  2,  2,
	 1,  1,  2,  2,  2,  2,  2,  2,
	 1,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,

	 1,  1,  1,  2,  2,  2,  2,  2,
	 1,  1,  2,  2,  2,  2,  2,  2,
	 1,  2,  2,  2,  2,  2,  2,  4,
	 2,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,

	 1,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,

	 1,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  4,
	 2,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,

	 1,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,
	 2,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,
	 4,  4,  4,  4,  4,  4,  4,  4,

	 1,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,
	 2,  4,  4,  4,  4,  4,  4,  8,
	 4,  4,  4,  4,  4,  4,  8,  8,
	 4,  4,  4,  4,  4,  8,  8,  8,
	 4,  4,  4,  4,  8,  8,  8,  8,
	 4,  4,  4,  8,  8,  8,  8,  8,
	 4,  4,  8,  8,  8,  8,  8,  8,

	 1,  4,  4,  4,  4,  4,  8,  8,
	 4,  4,  4,  4,  4,  8,  8,  8,
	 4,  4,  4,  4,  8,  8,  8,  8,
	 4,  4,  4,  8,  8,  8,  8,  8,
	 4,  4,  8,  8,  8,  8,  8,  8,
	 4,  8,  8,  8,  8,  8,  8,  8,
	 8,  8,  8,  8,  8,  8,  8,  8,
	 8,  8,  8,  8,  8,  8,  8,  8,

	 1,  4,  4,  8,  8,  8,  8,  8,
	 4,  4,  8,  8,  8,  8,  8,  8,
	 4,  8,  8,  8,  8,  8,  8, 16,
	 8,  8,  8,  8,  8,  8, 16, 16,
	 8,  8,  8,  8,  8, 16, 16, 16,
	 8,  8,  8,  8, 16, 16, 16, 16,
	 8,  8,  8, 16, 16, 16, 16, 16,
	 8,  8, 16, 16, 16, 16, 16, 16,

	 1,  8,  8,  8,  8,  8, 16, 16,
	 8,  8,  8,  8,  8, 16, 16, 16,
	 8,  8,  8,  8, 16, 16, 16, 16,
	 8,  8,  8, 16, 16, 16, 16, 16,
	 8,  8, 16, 16, 16, 16, 16, 16,
	 8, 16, 16, 16, 16, 16, 16, 16,
	16, 16, 16, 16, 16, 16, 16, 16,
	16, 16, 16, 16, 16, 16, 16, 16,

	 1,  8,  8, 16, 16, 16, 16, 16,
	 8,  8, 16, 16, 16, 16, 16, 16,
	 8, 16, 16, 16, 16, 16, 16, 32,
	16, 16, 16, 16, 16, 16, 32, 32,
	16, 16, 16, 16, 16, 32, 32, 32,
	16, 16, 16, 16, 32, 32, 32, 32,
	16, 16, 16, 32, 32, 32, 32, 32,
	16, 16, 32, 32, 32, 32, 32, 32,

	 1, 16, 16, 16, 16, 16, 32, 32,
	16, 16, 16, 16, 16, 32, 32, 32,
	16, 16, 16, 16, 32, 32, 32, 32,
	16, 16, 16, 32, 32, 32, 32, 32,
	16, 16, 32, 32, 32, 32, 32, 32,
	16, 32, 32, 32, 32, 32, 32, 32,
	32, 32, 32, 32, 32, 32, 32, 32,
	32, 32, 32, 32, 32, 32, 32, 32
};


const int16_t quantization_step_248_extended[13*64] = {
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,
	 1,  1,  1,  1,  1,  1,  1,  1,

	 1,  1,  1,  1,  1,  1,  1,  2,
	 1,  1,  1,  1,  1,  1,  2,  2,
	 1,  1,  1,  1,  1,  2,  2,  2,
	 1,  1,  1,  1,  2,  2,  2,  2,
	 1,  1,  1,  1,  1,  1,  1,  2,
	 1,  1,  1,  1,  1,  1,  2,  2,
	 1,  1,  1,  1,  1,  2,  2,  2,
	 1,  1,  1,  2,  2,  2,  2,  2,

	 1,  1,  1,  1,  1,  2,  2,  2,
	 1,  1,  1,  2,  2,  2,  2,  2,
	 1,  1,  2,  2,  2,  2,  2,  2,
	 1,  2,  2,  2,  2,  2,  2,  2,
	 1,  1,  1,  1,  2,  2,  2,  2,
	 1,  1,  1,  2,  2,  2,  2,  2,
	 1,  1,  2,  2,  2,  2,  2,  2,
	 1,  2,  2,  2,  2,  2,  2,  2,

	 1,  1,  2,  2,  2,  2,  2,  4,
	 1,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 1,  1,  2,  2,  2,  2,  2,  4,
	 1,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,

	 1,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,
	 2,  2,  2,  2,  2,  2,  2,  2,

	 1,  2,  2,  2,  2,  2,  2,  4,
	 2,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 2,  2,  2,  2,  2,  2,  2,  4,
	 2,  2,  2,  2,  2,  2,  4,  4,
	 2,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,

	 1,  2,  2,  2,  2,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,
	 2,  4,  4,  4,  4,  4,  4,  4,
	 2,  2,  2,  2,  4,  4,  4,  4,
	 2,  2,  2,  4,  4,  4,  4,  4,
	 2,  2,  4,  4,  4,  4,  4,  4,
	 2,  4,  4,  4,  4,  4,  4,  4,

	 1,  2,  4,  4,  4,  4,  4,  8,
	 2,  4,  4,  4,  4,  4,  8,  8,
	 4,  4,  4,  4,  4,  8,  8,  8,
	 4,  4,  4,  4,  8,  8,  8,  8,
	 2,  2,  4,  4,  4,  4,  4,  8,
	 2,  4,  4,  4,  4,  4,  8,  8,
	 4,  4,  4,  4,  4,  8,  8,  8,
	 4,  4,  4,  8,  8,  8,  8,  8,

	 1,  4,  4,  4,  4,  8,  8,  8,
	 4,  4,  4,  8,  8,  8,  8,  8,
	 4,  4,  8,  8,  8,  8,  8,  8,
	 4,  8,  8,  8,  8,  8,  8,  8,
	 4,  4,  4,  4,  8,  8,  8,  8,
	 4,  4,  4,  8,  8,  8,  8,  8,
	 4,  4,  8,  8,  8,  8,  8,  8,
	 4,  8,  8,  8,  8,  8,  8,  8,

	 1,  4,  8,  8,  8,  8,  8, 16,
	 4,  8,  8,  8,  8,  8, 16, 16,
	 8,  8,  8,  8,  8, 16, 16, 16,
	 8,  8,  8,  8, 16, 16, 16, 16,
	 4,  4,  8,  8,  8,  8,  8, 16,
	 4,  8,  8,  8,  8,  8, 16, 16,
	 8,  8,  8,  8,  8, 16, 16, 16,
	 8,  8,  8, 16, 16, 16, 16, 16,

	 1,  8,  8,  8,  8, 16, 16, 16,
	 8,  8,  8, 16, 16, 16, 16, 16,
	 8,  8, 16, 16, 16, 16, 16, 16,
	 8, 16, 16, 16, 16, 16, 16, 16,
	 8,  8,  8,  8, 16, 16, 16, 16,
	 8,  8,  8, 16, 16, 16, 16, 16,
	 8,  8, 16, 16, 16, 16, 16, 16,
	 8, 16, 16, 16, 16, 16, 16, 16,

	 1,  8, 16, 16, 16, 16, 16, 32,
	 8, 16, 16, 16, 16, 16, 32, 32,
	16, 16, 16, 16, 16, 32, 32, 32,
	16, 16, 16, 16, 32, 32, 32, 32,
	 8,  8, 16, 16, 16, 16, 16, 32,
	 8, 16, 16, 16, 16, 16, 32, 32,
	16, 16, 16, 16, 16, 32, 32, 32,
	16, 16, 16, 32, 32, 32, 32, 32,

	 1, 16, 16, 16, 16, 32, 32, 32,
	16, 16, 16, 32, 32, 32, 32, 32,
	16, 16, 32, 32, 32, 32, 32, 32,
	16, 32, 32, 32, 32, 32, 32, 32,
	16, 16, 16, 16, 32, 32, 32, 32,
	16, 16, 16, 32, 32, 32, 32, 32,
	16, 16, 32, 32, 32, 32, 32, 32,
	16, 32, 32, 32, 32, 32, 32, 32
};


const int16_t W_88_inv_16bit[64] = {
	 32767,  16705,  17734,  18205,  18725,  19266,  21407,  22725,
	 16705,  17032,  18081,  18562,  19091,  19643,  21826,  23170,
	 17734,  18081,  19195,  19705,  20267,  20853,  23170,  24598,
	 18205,  18562,  19705,  20228,  20806,  21407,  23786,  25251,
	 18725,  19091,  20267,  20806,  21400,  22018,  24465,  25972,
	 19266,  19643,  20853,  21407,  22018,  22654,  25172,  26722,
	 21407,  21826,  23170,  23786,  24465,  25172,  27969,  29692,
	 22725,  23170,  24598,  25251,  25972,  26722,  29692,  31521
};


const int16_t W_248_inv_16bit[64] = {
	 32767,  16705,  17734,  18205,  18725,  19266,  21407,  22725,
	 17734,  18081,  19195,  19705,  20267,  20853,  23170,  24598,
	 18725,  19091,  20267,  20806,  21400,  22018,  24465,  25972,
	 21407,  21826,  23170,  23786,  24465,  25172,  27969,  29692,
	 16384,  16705,  17734,  18205,  18725,  19266,  21407,  22725,
	 17734,  18081,  19195,  19705,  20267,  20853,  23170,  24598,
	 18725,  19091,  20267,  20806,  21400,  22018,  24465,  25972,
	 21407,  21826,  23170,  23786,  24465,  25172,  27969,  29692
};

