%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

DEBUG_ENABLE = 0;
DEBUG_FILENAME = 'decode_vlc_tables.txt';
OUTPUT_FILENAME = 'decode_vlc_tables.h';


vlc_code_table;

AMP_FACTOR = 16;
DECODE_VLC_GETNEXTBIT = 0;
DECODE_VLC_VALID = 1;
DECODE_VLC_EOB = 2;
DECODE_VLC_ERROR = 3;


len = ones(3,1);
code = [0;0;1];
risc_code = zeros(3,3);
risc_code(1,1) = DECODE_VLC_GETNEXTBIT; 
risc_code(1,2) = 1;
risc_code(1,3) = 0;

N_lines_cluster = 2;
i_actual = 2;
i_next = N_lines_cluster + i_actual;	%next free line

for l=[1:17]
   
for k=[1:N_lines_cluster]
	[run, amp] = get_runamp( code(i_actual), len(i_actual), run_table, amp_table, code_table, len_table );
   if (isnan(run) | isnan(amp))
      risc_code(i_actual,1) = DECODE_VLC_GETNEXTBIT; 
      risc_code(i_actual,2) = i_next - 1;
      risc_code(i_actual,3) = 0;
      code(i_next) = code(i_actual)*2 + 0;
      code(i_next+1) = code(i_actual)*2 + 1;
      len(i_next) = len(i_actual)+1;
      len(i_next+1) = len(i_actual)+1;
      i_next = i_next + 2;
   elseif ((run==-1)&(amp==0))
      risc_code(i_actual,1) = DECODE_VLC_EOB; 
      risc_code(i_actual,2) = 0;
      risc_code(i_actual,3) = 0;
   elseif ((run==-1)&(amp==-1))
      risc_code(i_actual,1) = DECODE_VLC_ERROR; 
      risc_code(i_actual,2) = 0;
      risc_code(i_actual,3) = 0;
   else
      risc_code(i_actual,1) = DECODE_VLC_VALID; 
      risc_code(i_actual,2) = run;
      risc_code(i_actual,3) = amp*AMP_FACTOR;
   end
   
   i_actual = i_actual + 1;
end
N_lines_cluster = i_next - i_actual;

end







if (exist( 'OUTPUT_FILENAME' )==1)
   fid = fopen( OUTPUT_FILENAME, 'w' );
else
   fid = 1;
end

N_lines = size(risc_code,1);
fprintf(fid,'\n// risc program for decoding vlc - generated by matlab\n');
fprintf(fid, 'const uint32_t decode_vlc_risc_program[%i] = {', N_lines);
for k=[1:N_lines]
   x1 = risc_code(k,1)*2^14 + risc_code(k,2);
   x2 = risc_code(k,3);
   if (x2<0)
      x2 = x2 + 2^16; 
   end
   if (rem(k-1,8)==0)
      fprintf(fid, '\n\t');
   end
   fprintf(fid, '0x%04x%04x', x1, x2);
   if (k~=N_lines)
      fprintf(fid, ', ');
   end
end
fprintf(fid, '\n};\n');









% this is for debugging only
if( DEBUG_ENABLE==1 )
   if (exist( 'DEBUG_FILENAME' )==1)
      fid = fopen( DEBUG_FILENAME, 'w' );
   else
      fid = 1;
   end
   
N_bits=16;
for k=[1:size(risc_code,1)]
   code_binary = fliplr( de2bi( code(k),len(k)) );

   fprintf(fid,'%4i | ',k-1);		%line number
   for n=[1:len(k)]
      fprintf(fid,'%i', code_binary(n));
   end
   for n=[(len(k)+1):N_bits]
      fprintf(fid,' ');
   end
   fprintf(fid,' | %i | %4i | %3i\n', risc_code(k,1), risc_code(k,2), risc_code(k,3) );
end

	fclose('all');

end
