%******************************************************************************
%*                                                                            *
%*  Cedocida DV-Codec                                                         *
%*                                                                            *
%*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              *
%*  Project start: 15.12.2003                                                 *
%*  Last change  : 08.05.2005                                                 *
%*                                                                            *
%******************************************************************************
%*                                                                            *
%*  This program is free software; you can redistribute it and/or modify      *
%*  it under the terms of the GNU General Public License as published by      *
%*  the Free Software Foundation; either version 2 of the License, or         *
%*  (at your option) any later version.                                       *
%*                                                                            *
%*  This program is distributed in the hope that it will be useful,           *
%*  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
%*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
%*  GNU General Public License for more details.                              *
%*                                                                            *
%*  You should have received a copy of the GNU General Public License         *
%*  along with this program; if not, write to the Free Software               *
%*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
%*                                                                            *
%******************************************************************************

function [code, len] = get_code( run, amp, code_table, run_table, amp_table )

	indx = find( (run_table==run) & (amp_table==amp) );

   if ((run>5) & (amp==0))
      code = 126*2^6 + run;
      len = 13;
   elseif ((run==0) & (amp>22))
      code = 127*2^8 + amp;
      len = 15;
   elseif isempty(indx)
      run1 = run-1;
      amp1 = 0;
      indx1 = find( (run_table==run1) & (amp_table==amp1) );
      if ((run1>5) & (amp1==0))
      	code1 = 126*2^6 + run1;
      	len1 = 13;
   	elseif ((run1==0) & (amp1>22))
      	code1 = 127*2^8 + amp1;
         len1 = 15;
      else
         code1 = hex2dec( code_table{indx1}{3} );
         len1 = code_table{indx1}{4};
      end
      
      run2 = 0;
      amp2 = amp;
      indx2 = find( (run_table==run2) & (amp_table==amp2) );
      if ((run2>5) & (amp2==0))
      	code2 = 126*2^6 + run2;
      	len2 = 13;
   	elseif ((run2==0) & (amp2>22))
      	code2 = 127*2^8 + amp2;
         len2 = 15;
      else
         code2 = hex2dec( code_table{indx2}{3} );
         len2 = code_table{indx2}{4};
      end
      
      len = len1+len2;
      code = code1*2^len2 + code2;
   else
	   code = hex2dec( code_table{indx}{3} );
   	len = code_table{indx}{4};
   end
    
   


