/******************************************************************************/
/*                                                                            */
/*  Cedocida DV-Codec                                                         */
/*                                                                            */
/*  Copyright (C) 2005 Andreas Dittrich <dittrich@eit.uni-kl.de>              */
/*  Project start: 15.12.2003                                                 */
/*  Last change  : 08.05.2005                                                 */
/*                                                                            */
/******************************************************************************/
/*                                                                            */
/*  This program is free software; you can redistribute it and/or modify      */
/*  it under the terms of the GNU General Public License as published by      */
/*  the Free Software Foundation; either version 2 of the License, or         */
/*  (at your option) any later version.                                       */
/*                                                                            */
/*  This program is distributed in the hope that it will be useful,           */
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/*  GNU General Public License for more details.                              */
/*                                                                            */
/*  You should have received a copy of the GNU General Public License         */
/*  along with this program; if not, write to the Free Software               */
/*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                            */
/******************************************************************************/



struct VLC16 {
	uint16_t code;
	uint16_t length;
};

struct VLC32 {
	uint32_t code;
	uint32_t length;
};



const VLC16 vlc_table1[62] =
{
// run=0..61, amp=0, sign=0 (code and length with sign!)
	{ 0x07ce, 11 }, { 0x07cf, 11 }, { 0x0fac, 12 }, { 0x0fad, 12 }, 
	{ 0x0fae, 12 }, { 0x0faf, 12 }, { 0x1f86, 13 }, { 0x1f87, 13 }, 
	{ 0x1f88, 13 }, { 0x1f89, 13 }, { 0x1f8a, 13 }, { 0x1f8b, 13 }, 
	{ 0x1f8c, 13 }, { 0x1f8d, 13 }, { 0x1f8e, 13 }, { 0x1f8f, 13 }, 
	{ 0x1f90, 13 }, { 0x1f91, 13 }, { 0x1f92, 13 }, { 0x1f93, 13 }, 
	{ 0x1f94, 13 }, { 0x1f95, 13 }, { 0x1f96, 13 }, { 0x1f97, 13 }, 
	{ 0x1f98, 13 }, { 0x1f99, 13 }, { 0x1f9a, 13 }, { 0x1f9b, 13 }, 
	{ 0x1f9c, 13 }, { 0x1f9d, 13 }, { 0x1f9e, 13 }, { 0x1f9f, 13 }, 
	{ 0x1fa0, 13 }, { 0x1fa1, 13 }, { 0x1fa2, 13 }, { 0x1fa3, 13 }, 
	{ 0x1fa4, 13 }, { 0x1fa5, 13 }, { 0x1fa6, 13 }, { 0x1fa7, 13 }, 
	{ 0x1fa8, 13 }, { 0x1fa9, 13 }, { 0x1faa, 13 }, { 0x1fab, 13 }, 
	{ 0x1fac, 13 }, { 0x1fad, 13 }, { 0x1fae, 13 }, { 0x1faf, 13 }, 
	{ 0x1fb0, 13 }, { 0x1fb1, 13 }, { 0x1fb2, 13 }, { 0x1fb3, 13 }, 
	{ 0x1fb4, 13 }, { 0x1fb5, 13 }, { 0x1fb6, 13 }, { 0x1fb7, 13 }, 
	{ 0x1fb8, 13 }, { 0x1fb9, 13 }, { 0x1fba, 13 }, { 0x1fbb, 13 }, 
	{ 0x1fbc, 13 }, { 0x1fbd, 13 }
};

const VLC16 vlc_table2[256] =
{
// run=0, amp=0..255, sign=0 (code and length with sign!)
	{ 0x07ce, 11 }, { 0x0000,  3 }, { 0x0004,  4 }, { 0x0010,  5 }, 
	{ 0x0012,  5 }, { 0x002c,  6 }, { 0x002e,  6 }, { 0x0064,  7 }, 
	{ 0x0066,  7 }, { 0x00da,  8 }, { 0x00dc,  8 }, { 0x00de,  8 }, 
	{ 0x01d4,  9 }, { 0x01d6,  9 }, { 0x01d8,  9 }, { 0x01da,  9 }, 
	{ 0x01dc,  9 }, { 0x01de,  9 }, { 0x03d6, 10 }, { 0x03d8, 10 }, 
	{ 0x03da, 10 }, { 0x03dc, 10 }, { 0x03de, 10 }, { 0xfe2e, 16 }, 
	{ 0xfe30, 16 }, { 0xfe32, 16 }, { 0xfe34, 16 }, { 0xfe36, 16 }, 
	{ 0xfe38, 16 }, { 0xfe3a, 16 }, { 0xfe3c, 16 }, { 0xfe3e, 16 }, 
	{ 0xfe40, 16 }, { 0xfe42, 16 }, { 0xfe44, 16 }, { 0xfe46, 16 }, 
	{ 0xfe48, 16 }, { 0xfe4a, 16 }, { 0xfe4c, 16 }, { 0xfe4e, 16 }, 
	{ 0xfe50, 16 }, { 0xfe52, 16 }, { 0xfe54, 16 }, { 0xfe56, 16 }, 
	{ 0xfe58, 16 }, { 0xfe5a, 16 }, { 0xfe5c, 16 }, { 0xfe5e, 16 }, 
	{ 0xfe60, 16 }, { 0xfe62, 16 }, { 0xfe64, 16 }, { 0xfe66, 16 }, 
	{ 0xfe68, 16 }, { 0xfe6a, 16 }, { 0xfe6c, 16 }, { 0xfe6e, 16 }, 
	{ 0xfe70, 16 }, { 0xfe72, 16 }, { 0xfe74, 16 }, { 0xfe76, 16 }, 
	{ 0xfe78, 16 }, { 0xfe7a, 16 }, { 0xfe7c, 16 }, { 0xfe7e, 16 }, 
	{ 0xfe80, 16 }, { 0xfe82, 16 }, { 0xfe84, 16 }, { 0xfe86, 16 }, 
	{ 0xfe88, 16 }, { 0xfe8a, 16 }, { 0xfe8c, 16 }, { 0xfe8e, 16 }, 
	{ 0xfe90, 16 }, { 0xfe92, 16 }, { 0xfe94, 16 }, { 0xfe96, 16 }, 
	{ 0xfe98, 16 }, { 0xfe9a, 16 }, { 0xfe9c, 16 }, { 0xfe9e, 16 }, 
	{ 0xfea0, 16 }, { 0xfea2, 16 }, { 0xfea4, 16 }, { 0xfea6, 16 }, 
	{ 0xfea8, 16 }, { 0xfeaa, 16 }, { 0xfeac, 16 }, { 0xfeae, 16 }, 
	{ 0xfeb0, 16 }, { 0xfeb2, 16 }, { 0xfeb4, 16 }, { 0xfeb6, 16 }, 
	{ 0xfeb8, 16 }, { 0xfeba, 16 }, { 0xfebc, 16 }, { 0xfebe, 16 }, 
	{ 0xfec0, 16 }, { 0xfec2, 16 }, { 0xfec4, 16 }, { 0xfec6, 16 }, 
	{ 0xfec8, 16 }, { 0xfeca, 16 }, { 0xfecc, 16 }, { 0xfece, 16 }, 
	{ 0xfed0, 16 }, { 0xfed2, 16 }, { 0xfed4, 16 }, { 0xfed6, 16 }, 
	{ 0xfed8, 16 }, { 0xfeda, 16 }, { 0xfedc, 16 }, { 0xfede, 16 }, 
	{ 0xfee0, 16 }, { 0xfee2, 16 }, { 0xfee4, 16 }, { 0xfee6, 16 }, 
	{ 0xfee8, 16 }, { 0xfeea, 16 }, { 0xfeec, 16 }, { 0xfeee, 16 }, 
	{ 0xfef0, 16 }, { 0xfef2, 16 }, { 0xfef4, 16 }, { 0xfef6, 16 }, 
	{ 0xfef8, 16 }, { 0xfefa, 16 }, { 0xfefc, 16 }, { 0xfefe, 16 }, 
	{ 0xff00, 16 }, { 0xff02, 16 }, { 0xff04, 16 }, { 0xff06, 16 }, 
	{ 0xff08, 16 }, { 0xff0a, 16 }, { 0xff0c, 16 }, { 0xff0e, 16 }, 
	{ 0xff10, 16 }, { 0xff12, 16 }, { 0xff14, 16 }, { 0xff16, 16 }, 
	{ 0xff18, 16 }, { 0xff1a, 16 }, { 0xff1c, 16 }, { 0xff1e, 16 }, 
	{ 0xff20, 16 }, { 0xff22, 16 }, { 0xff24, 16 }, { 0xff26, 16 }, 
	{ 0xff28, 16 }, { 0xff2a, 16 }, { 0xff2c, 16 }, { 0xff2e, 16 }, 
	{ 0xff30, 16 }, { 0xff32, 16 }, { 0xff34, 16 }, { 0xff36, 16 }, 
	{ 0xff38, 16 }, { 0xff3a, 16 }, { 0xff3c, 16 }, { 0xff3e, 16 }, 
	{ 0xff40, 16 }, { 0xff42, 16 }, { 0xff44, 16 }, { 0xff46, 16 }, 
	{ 0xff48, 16 }, { 0xff4a, 16 }, { 0xff4c, 16 }, { 0xff4e, 16 }, 
	{ 0xff50, 16 }, { 0xff52, 16 }, { 0xff54, 16 }, { 0xff56, 16 }, 
	{ 0xff58, 16 }, { 0xff5a, 16 }, { 0xff5c, 16 }, { 0xff5e, 16 }, 
	{ 0xff60, 16 }, { 0xff62, 16 }, { 0xff64, 16 }, { 0xff66, 16 }, 
	{ 0xff68, 16 }, { 0xff6a, 16 }, { 0xff6c, 16 }, { 0xff6e, 16 }, 
	{ 0xff70, 16 }, { 0xff72, 16 }, { 0xff74, 16 }, { 0xff76, 16 }, 
	{ 0xff78, 16 }, { 0xff7a, 16 }, { 0xff7c, 16 }, { 0xff7e, 16 }, 
	{ 0xff80, 16 }, { 0xff82, 16 }, { 0xff84, 16 }, { 0xff86, 16 }, 
	{ 0xff88, 16 }, { 0xff8a, 16 }, { 0xff8c, 16 }, { 0xff8e, 16 }, 
	{ 0xff90, 16 }, { 0xff92, 16 }, { 0xff94, 16 }, { 0xff96, 16 }, 
	{ 0xff98, 16 }, { 0xff9a, 16 }, { 0xff9c, 16 }, { 0xff9e, 16 }, 
	{ 0xffa0, 16 }, { 0xffa2, 16 }, { 0xffa4, 16 }, { 0xffa6, 16 }, 
	{ 0xffa8, 16 }, { 0xffaa, 16 }, { 0xffac, 16 }, { 0xffae, 16 }, 
	{ 0xffb0, 16 }, { 0xffb2, 16 }, { 0xffb4, 16 }, { 0xffb6, 16 }, 
	{ 0xffb8, 16 }, { 0xffba, 16 }, { 0xffbc, 16 }, { 0xffbe, 16 }, 
	{ 0xffc0, 16 }, { 0xffc2, 16 }, { 0xffc4, 16 }, { 0xffc6, 16 }, 
	{ 0xffc8, 16 }, { 0xffca, 16 }, { 0xffcc, 16 }, { 0xffce, 16 }, 
	{ 0xffd0, 16 }, { 0xffd2, 16 }, { 0xffd4, 16 }, { 0xffd6, 16 }, 
	{ 0xffd8, 16 }, { 0xffda, 16 }, { 0xffdc, 16 }, { 0xffde, 16 }, 
	{ 0xffe0, 16 }, { 0xffe2, 16 }, { 0xffe4, 16 }, { 0xffe6, 16 }, 
	{ 0xffe8, 16 }, { 0xffea, 16 }, { 0xffec, 16 }, { 0xffee, 16 }, 
	{ 0xfff0, 16 }, { 0xfff2, 16 }, { 0xfff4, 16 }, { 0xfff6, 16 }, 
	{ 0xfff8, 16 }, { 0xfffa, 16 }, { 0xfffc, 16 }, { 0xfffe, 16 }
}; 

const VLC32 vlc_table3[4*17] =
{
// run=1..4, amp=1..17, sign=0 (code and length with sign!)
// run= 1
	{ 0x0000000e,  5 }, { 0x0000002a,  6 }, { 0x000000d6,  8 }, { 0x000000d8,  8 }, 
	{ 0x000001ce,  9 }, { 0x000001d0,  9 }, { 0x000001d2,  9 }, { 0x000003d4, 10 }, 
	{ 0x000007c8, 11 }, { 0x000007ca, 11 }, { 0x000007cc, 11 }, { 0x00000fa6, 12 }, 
	{ 0x00000fa8, 12 }, { 0x00000faa, 12 }, { 0x00001f7a, 13 }, { 0x00001f7c, 13 }, 
	{ 0x00001f7e, 13 }, 
// run= 2
	{ 0x00000028,  6 }, { 0x000000d4,  8 }, { 0x000001cc,  9 }, { 0x000003d0, 10 }, 
	{ 0x000003d2, 10 }, { 0x000007c6, 11 }, { 0x00001f70, 13 }, { 0x00001f72, 13 }, 
	{ 0x00001f74, 13 }, { 0x00001f76, 13 }, { 0x00001f78, 13 }, { 0x000f9fd4, 20 }, 
	{ 0x000f9fd6, 20 }, { 0x000f9fd8, 20 }, { 0x000f9fda, 20 }, { 0x000f9fdc, 20 }, 
	{ 0x000f9fde, 20 }, 
// run= 3
	{ 0x00000060,  7 }, { 0x000001c8,  9 }, { 0x000003cc, 10 }, { 0x000007c2, 11 }, 
	{ 0x000007c4, 11 }, { 0x00000fa4, 12 }, { 0x00001f6e, 13 }, { 0x0007d666, 19 }, 
	{ 0x000facda, 20 }, { 0x000facdc, 20 }, { 0x000facde, 20 }, { 0x001f59d4, 21 }, 
	{ 0x001f59d6, 21 }, { 0x001f59d8, 21 }, { 0x001f59da, 21 }, { 0x001f59dc, 21 }, 
	{ 0x001f59de, 21 }, 
// run= 4
	{ 0x00000062,  7 }, { 0x000001ca,  9 }, { 0x000003ce, 10 }, { 0x00000fa2, 12 }, 
	{ 0x00001f6c, 13 }, { 0x0003eb6e, 18 }, { 0x0007d6e4, 19 }, { 0x0007d6e6, 19 }, 
	{ 0x000fadda, 20 }, { 0x000faddc, 20 }, { 0x000fadde, 20 }, { 0x001f5bd4, 21 }, 
	{ 0x001f5bd6, 21 }, { 0x001f5bd8, 21 }, { 0x001f5bda, 21 }, { 0x001f5bdc, 21 }, 
	{ 0x001f5bde, 21 }
};

const VLC32 vlc_table4[10*3] =
{
// run=5..14, amp=1..3, sign=0 (code and length with sign!)
// run= 5
	{ 0x000000d0,  8 }, { 0x000003c8, 10 }, { 0x000007c0, 11 }, 
// run= 6
	{ 0x000000d2,  8 }, { 0x000003ca, 10 }, { 0x00000fa0, 12 }, 
// run= 7
	{ 0x000001c0,  9 }, { 0x00001f60, 13 }, { 0x00001f68, 13 }, 
// run= 8
	{ 0x000001c2,  9 }, { 0x00001f62, 13 }, { 0x00001f6a, 13 }, 
// run= 9
	{ 0x000001c4,  9 }, { 0x00001f64, 13 }, { 0x0003f110, 18 }, 
// run=10
	{ 0x000001c6,  9 }, { 0x00001f66, 13 }, { 0x0003f130, 18 }, 
// run=11
	{ 0x000003c0, 10 }, { 0x0001f8a4, 17 }, { 0x0003f150, 18 }, 
// run=12
	{ 0x000003c2, 10 }, { 0x0001f8b4, 17 }, { 0x0003f170, 18 }, 
// run=13
	{ 0x000003c4, 10 }, { 0x0001f8c4, 17 }, { 0x0003f190, 18 }, 
// run=14
	{ 0x000003c6, 10 }, { 0x0001f8d4, 17 }, { 0x0003f1b0, 18 }
};


